% my_MBE.m 
% Mafuyu Kitahara
% 6/14/2000
% adaptive + MBE analysis (based on StraightV30kr16)
% Input: "xold", output of "my_IN.m" script
% Output: bunch of variables on Matlab workspace. Use "my_plot" to plot
%	  results. Use "my_plotmark" for segmentation

% parameter initialization
	hr='on';
	tpath=pwd;
	f0floor=50;	% default was 40
	f0ceil=300;	% default was 800, 300 for mk
	fs=44100;	% default sampling frequency (Hz) was 22050
	framem=60;	% default frame length for pitch extraction (ms), 40
	shiftm=1;       % default frame shift (ms) for spectrogram
	f0shiftm=1;     % default frame shift (ms) for F0 information
	fftl=2048;	% default FFT length, was 1024
	eta=1.4;        % time window stretch factor
	pc=0.6;         % exponent for nonlinearity
	mag=0.2;        
	framel=framem*fs/1000;

%------------------------------------------------------
%	analysis part 
%------------------------------------------------------

  nvo=24;
  nvc=ceil(log(f0ceil/f0floor)/log(2)*nvo);
  [f0v,vrv,dfv,nf,aav]=fixpF0VexMltpBG4(xold,fs,f0floor,nvc,nvo,1.2,1,shiftm,1,5,0.5,1);
  [nn,mm]=size(f0v);
  [pwt,pwh]=plotcpower(xold,fs,shiftm);
  [f0raw,irms,df,amp]=f0track5(f0v,vrv,dfv,pwt,pwh,aav,shiftm);

  %% patched from 31/July/1999 part---
  dn=floor(fs/(800*3*2));
  [f0raw,ecr]=refineF02(decimate(xold,dn),fs/dn,f0raw,512,1.1,3,f0shiftm,1,length(f0raw));
  %%----------------------------------

  f0t=f0raw;avf0=mean(f0raw(f0raw>0));
  f0t(f0t==0)=f0t(f0t==0)*NaN;tt=1:length(f0t);

%mk this line was originally at the end of straightCiV1.m
  irmsz=irms*0;
	  
%- This part is for maintaining compatibility with old synthesis routine -
  f0var=max(0.00001,irms-irmsz).^2;
  f0var(f0var>0.99)=f0var(f0var>0.99)*0+100;
  f0var(f0raw==0)=f0var(f0raw==0)*0+100;
  f0varbak = f0var;  % backup for f0var (18/July/1999)
  f0var=f0var/2;  %  2 is a magic number. If everything is OK, it should be 1.
  f0var=(f0var>0.9);  % This modification is to make V/UV 
		      %decision crisp  (18/July/1999)
  f0varL=f0var;

%----------------------------------------
% Analysis part (core)
%----------------------------------------
  disp('% Now, adaptive window analysis has started. Please wait a moment.');
  [n2sgrambk,nsgram]=straightBodyC03m(xold,fs,shiftm,fftl,f0raw,f0var,f0varL,eta,pc);
     if mag>0
	  n2sgram=specreshape(fs,n2sgrambk,eta,pc,mag,f0raw);
     else
	  n2sgram=n2sgrambk;
     end;

%-----------------------------------------
%   MBE type analysis  2/Sept./1999
%-----------------------------------------     

  disp('% MBE type source information extraction starts this takes long');
  [apv,dpv]=aperiodicpart4(xold,fs,f0raw,f0shiftm,5,fftl/2+1);
  bv=boundmes2(apv,dpv,fs,f0shiftm,5,fftl/2+1);








