%% my_diffslope.m
%% Purpose: measure slope of the accent HL by differentiation

%% Mafuyu Kitahara
%% 8/03/2000

%% prepare matrices for work space
	awindow = 60;		% must be the same as my_f0mod...

	%% initialize matrices
	len = length(f0raw);
	tt=1:len;

%---------------------------------------------------------------------
% Approximation
%---------------------------------------------------------------------

%% filtered f0raw for approx, add "f0lead" for centering process

	f0lead = zeros(1,awindow);
	f0fill = cat(2,f0lead,f0raw);
	z = find (f0fill==0); 	% zero of f0fill
	f0fill(z) = 80;	% fill devoiced part with low-end of pitch range
			% (kinda arbitrary)
	ahalf = round(awindow/2);
	hh = ones(awindow,1)/awindow;	
	f0filt = conv(hh,f0fill);  	% convolution
	f0approx = f0filt(awindow+ahalf+1:len+awindow+ahalf); 	% centering
								% + adjust lead
%% get differentiation of approx for slope
	f0slope = diff(f0approx);

%%% plot

%% new figure
aa=figure;
%set(aa,'PaperPosition',[0.3 0.25 7 3.5]); % for portrait
orient landscape
set(aa,'Position',[40 130 1200 600]); %left, bottom, w, h

%% f0 original and approx

f0h = subplot('Position',[0.05 0.51 0.9 0.46]); %left, bottom, w, h
plot(tt,f0raw,tt,f0approx,'--');
	set(gca,'Ylim',[80 200]);
	set(gca,'Xlim',[0 900]);
	set(gca,'xtick',[]);
%	title(['original and smoothed f0 of ' fname]);
	title([fname]);
%	xlabel('time (ms)');
	ylabel('Frequency (Hz)');

% draw markers
	mky = [-50 5000];
	z = find(marks>0);
	lastmark = length(marks(z));

	for i=1:lastmark-1
		line([marks(i) marks(i)], mky, 'Color','black');
	end

%% f0 differentiation (slope)
z = zeros(1,len);

slph = subplot('Position',[0.05 0.05 0.9 0.44 ]); %left, bottom, w, h
plot(1:len-1,f0slope,'color','black');
line(1:len,z,'color','red','linestyle','-');
	set(gca,'Ylim',[-1.5 1.5]);
	set(gca,'Xlim',[0 900]);
	set(gca,'xtick',[]);
%	title('slope of smoothed f0');

% draw markers

	for i=1:lastmark-1
		line([marks(i) marks(i)], mky, 'Color','black');
	end

%%%% Let user specify the region and get the average-slope 

	user = ginput(1);		% click once
	areaindex = marks(1:lastmark)-user(1);	% get diff of click point and marks
	b = find(areaindex>0);		% find the first line after
						% the click point
	a= b-1;

	HLslope = mean(f0slope(marks(a(1)):marks(b(1))));
	indHLslope = find(f0slope(marks(a(1)):marks(b(1)))==HLslope);

%%%% mark the slope plot with a line and text

	x1 = [marks(a(1)) marks(b(1))]; 
	y1 = [HLslope-0.5 HLslope-0.5];
	HLslopetext = num2str(HLslope);

	axes(slph);
	line(x1, y1,'LineWidth',1.5,'Color','black','Marker','*');
        text(mean(x1),y1(1)-0.2,'mean HL slope = ',...
          'FontSize',14,'FontWeight','bold','HorizontalAlignment','right');
        text(mean(x1),y1(1)-0.2,HLslopetext,...
          'FontSize',14,'FontWeight','bold','HorizontalAlignment','left');

%%%% output to FILE

	slpfname = 'slope.txt';
  	fid = fopen(slpfname,'a');
		fprintf(fid,'%s\t',fname);
		fprintf(fid,'%s\n',HLslopetext);
   	fclose(fid); 





