% my_plots2
% Show spectrogram and F0, without marking points
% Mafuyu Kitahara
% 6/1/2000 created

% parameter initialization
%		hr='on';
%		tpath=pwd;
%		f0floor=40;
%		f0ceil=800;
% 		fs=44100;	% default sampling frequency (Hz) was 22050
% 		framem=40;	% default frame length for pitch extraction (ms)
%		shiftm=1;       % default frame shift (ms) for spectrogram
%		f0shiftm=1;     % default frame shift (ms) for F0 information
%		fftl=2048;	% default FFT length was 1024
%		eta=1.4;        % time window stretch factor
%		pc=0.6;         % exponent for nonlinearity
%		mag=0.2;      % This parameter should be revised.
%		framel=framem*fs/1000;

% Figure parameters

aa=figure;
set(aa,'PaperPosition',[0.3 0.25 7 3.5]);
set(aa,'Position',[40 330 1200 600]);

% Spectrogram part
    
	mxil=max(max(dB(nsgram+0.001)));
	[nsy,nsx]=size(nsgram);
      
 	sgrh = subplot('Position',[0.05 0.525 0.9 0.435 ]); %left, bottom, w, h
     	imagesc((0:nsx-1)*shiftm,(0:nsy-1)/nsy*fs/2, ...
 	        max(dB(nsgram+0.001),mxil-50));
		axis('xy');colormap(1-gray);
		set(gca,'xtick',[]);
		set(gca,'Ylim',[0 5000]);
	  title([fname]);
%	  xlabel('time (ms)');
	  ylabel('Frequency (Hz)');
     
% F0 trajectory part
     
	f0h = subplot('Position',[0.05 0.1 0.9 0.38 ]);
    	plot(tt*shiftm,f0t,'r');grid on; 
	set(gca,'xaxislocation','top');
	set(gca,'Ylim',[70 200]); 
	if ~isnan(avf0)
	  axis([1 max(tt)*shiftm ...
	      min(avf0/sqrt(2),0.95*min(f0raw(f0raw>0)))  ...
		  max(avf0*sqrt(2),1.05*max(f0raw(f0raw>0)))]);
	  end;
%	  	xlabel('time (ms)');
		ylabel('F0 (Hz)');

% add label field
	labh = subplot('Position',[0.05 0.01 0.9 0.09]);grid on;
		set(gca,'xtick',[]);
		set(gca,'ytick',[]);
		axis([1 nsx 0 1]);






