% my_plotmark.m
% Show spectrogram and F0, prompt user to label 9 points
% Mafuyu Kitahara
% 5/14/2000 	created
% 5/24      	minor modification: add another marker
% 5/31		minor modification: move axis labels

% Figure parameters

aa=figure;
orient landscape;
%set(aa,'PaperPosition',[0.3 0.25 7 3.5]); % for portrait
set(aa,'Position',[40 330 1200 600]); % size on screen by pixel

% Spectrogram part
    
	mxil=max(max(dB(nsgram+0.001)));
	[nsy,nsx]=size(nsgram);
      
 	sgrh = subplot('Position',[0.05 0.525 0.9 0.435 ]); %left, bottom, w, h
     	imagesc((0:nsx-1)*shiftm,(0:nsy-1)/nsy*fs/2, ...
	max(dB(nsgram+0.001),mxil-50));
	axis('xy');colormap(1-gray);
	set(gca,'xtick',[]);
	set(gca,'Ylim',[0 5000]); 
	title([fname]);
%	xlabel('time (ms)');
	ylabel('Frequency (Hz)');
     
% F0 trajectory part
     
	f0h = subplot('Position',[0.05 0.1 0.9 0.38 ]);
    	plot(tt*shiftm,f0t,'r');grid on; 
	set(gca,'xaxislocation','top');
	set(gca,'Ylim',[70 200]);
	if ~isnan(avf0)
	  axis([1 max(tt)*shiftm ...
	      min(avf0/sqrt(2),0.95*min(f0raw(f0raw>0)))  ...
		  max(avf0*sqrt(2),1.05*max(f0raw(f0raw>0)))]);
	  end;
%	xlabel('time (ms)');
	ylabel('F0 (Hz)');

% add label field
	labh = subplot('Position',[0.05 0.01 0.9 0.09]);grid on;
		set(gca,'xtick',[]);
		set(gca,'ytick',[]);
		axis([1 nsx 0 1]);

% let user to mark 9 points 

% common for all marks
mky = [-50 5000];

% 
mk0 = gtext('0');
mk0_coord = get(mk0, 'Position');
mk0x = [mk0_coord(1,1) mk0_coord(1,1)];
mk0yb = [mk0_coord(1,2)+0.3 1];
axes(f0h);
line(mk0x, mky);
axes(sgrh);
line(mk0x, mky);
axes(labh);
line(mk0x,mk0yb);

mk1 = gtext('1');
mk1_coord = get(mk1, 'Position');
mk1x = [mk1_coord(1,1) mk1_coord(1,1)];
mk1yb = [mk1_coord(1,2)+0.3 1];
axes(f0h);
line(mk1x, mky);
axes(sgrh);
line(mk1x, mky);
axes(labh);
line(mk1x,mk1yb);

mk2 = gtext('2');
mk2_coord = get(mk2, 'Position');
mk2x = [mk2_coord(1,1) mk2_coord(1,1)];
mk2yb = [mk2_coord(1,2)+0.3 1];
axes(f0h);
line(mk2x, mky);
axes(sgrh);
line(mk2x, mky);
axes(labh);
line(mk2x,mk2yb);

mk3 = gtext('3');
mk3_coord = get(mk3, 'Position');
mk3x = [mk3_coord(1,1) mk3_coord(1,1)];
mk3yb = [mk3_coord(1,2)+0.3 1];
axes(f0h);
line(mk3x, mky);
axes(sgrh);
line(mk3x, mky);
axes(labh);
line(mk3x,mk3yb);

mk4 = gtext('4');
mk4_coord = get(mk4, 'Position');
mk4x = [mk4_coord(1,1) mk4_coord(1,1)];
mk4yb = [mk4_coord(1,2)+0.3 1];
axes(f0h);
line(mk4x, mky);
axes(sgrh);
line(mk4x, mky);
axes(labh);
line(mk4x,mk4yb);

mk5 = gtext('5');
mk5_coord = get(mk5, 'Position');
mk5x = [mk5_coord(1,1) mk5_coord(1,1)];
mk5yb = [mk5_coord(1,2)+0.3 1];
axes(f0h);
line(mk5x, mky);
axes(sgrh);
line(mk5x, mky);
axes(labh);
line(mk5x,mk5yb);

mk6 = gtext('6');
mk6_coord = get(mk6, 'Position');
mk6x = [mk6_coord(1,1) mk6_coord(1,1)];
mk6yb = [mk6_coord(1,2)+0.3 1];
axes(f0h);
line(mk6x, mky);
axes(sgrh);
line(mk6x, mky);
axes(labh);
line(mk6x,mk6yb);

mk7 = gtext('7');
mk7_coord = get(mk7, 'Position');
mk7x = [mk7_coord(1,1) mk7_coord(1,1)];
mk7yb = [mk7_coord(1,2)+0.3 1];
axes(f0h);
line(mk7x, mky);
axes(sgrh);
line(mk7x, mky);
axes(labh);
line(mk7x,mk7yb);

mk8 = gtext('8');
mk8_coord = get(mk8, 'Position');
mk8x = [mk8_coord(1,1) mk8_coord(1,1)];
mk8yb = [mk8_coord(1,2)+0.3 1];
axes(f0h);
line(mk8x, mky);
axes(sgrh);
line(mk8x, mky);
axes(labh);
line(mk8x,mk8yb);

% to show time axis labels, "f0h" handle should be current. 
axes(f0h);axes(sgrh);


	











