% my_specgrams.m
% Show 3 varieties of spectrogram 

% Mafuyu Kitahara
% 8/01/2000

%-----------------------------------------------------
% Figure parameters
%-----------------------------------------------------
	aa=figure;
	orient landscape;
	set(aa,'Position',[40 100 1200 800]); % size on screen by pixel

%-----------------------------------------------------
% Spectrogram part (comparison)
%-----------------------------------------------------

	% nsgram (Equal resolution spectrum)
	mxil=max(max(dB(nsgram+0.001)));
	[nsy,nsx]=size(nsgram);
 	subplot('Position',[0.05 0.68 0.9 0.29 ]); %left, bottom, w, h
     	imagesc((0:nsx-1)*shiftm,(0:nsy-1)/nsy*fs/2, ...
	max(dB(nsgram+0.001),mxil-50));
	axis('xy');colormap(1-gray);
	set(gca,'xtick',[]);
	set(gca,'Ylim',[0 4000]); 
	title(['equal resolution spectrum of ' fname ]);
%	xlabel('time (ms)');
	ylabel('Frequency (Hz)');

	%dispn2sgram'
	mxil=max(max(dB(n2sgram+0.001)));
	[nsy,nsx]=size(n2sgram);
 	subplot('Position',[0.05 0.36 0.9 0.29 ]); %left, bottom, w, h
	imagesc((0:nsx-1)*shiftm,(0:nsy-1)/nsy*fs/2,...
	max(real(dB(n2sgram+0.001)),mxil-50));
	axis('xy'); colormap(1-gray);
	set(gca,'xtick',[]);
	set(gca,'Ylim',[0 4000]); 
	title(['enhanced spectrum of ' fname ]);
%	xlabel('time (ms)');
	ylabel('frequency (Hz)');

	%dispn2sgrambk'
	mxil=max(max(dB(n2sgrambk+0.001)));
	[nsy,nsx]=size(n2sgrambk);
 	subplot('Position',[0.05 0.04 0.9 0.29 ]); %left, bottom, w, h
	imagesc((0:nsx-1)*shiftm,(0:nsy-1)/nsy*fs/2,...
	max(real(dB(n2sgrambk+0.001)),mxil-50));
	axis('xy'); colormap(1-gray);
	set(gca,'xtick',[]);
	set(gca,'Ylim',[0 4000]); 
	title(['Interpolated spectrum of ' fname ]);
	xlabel('time (ms)');
	ylabel('frequency (Hz)');

 


