% my_synOUT.m
% Purpose: resynthesize and save 
% Input:   f0mixes(i,len,j,k), output of my_f0modNN.m
% Mafuyu Kitahara
% 6/1/2000 created
% 6/13/2000 modified for 4-dimensional matrix
% 6/22/2000 modified to save parameters
% 6/26/2000 modified to save other parameters
% 8/04/2000 modified for phrasal H modification
%           now outputs will be "h1H1L1" for example.
%			h = phrasal H, H = H*, L = L% 

% creates directory. You must rename the directory
% before re-running this script.

mkdir current; % uncomment for batch process
cd current;

for i = 1:l 
 for j = 1:m 
  for k = 1:n 
        f0mix = f0mixes(i,:,j,k);

	z=find(f0mix==0);
	if length(z)~=length(tt) 

%-----------------------------------------------------
%       Synthesis parameters (Excised from straightCiV1)
%-----------------------------------------------------
	  pcnv=1.0; 	% pitch stretch factor (modify the whole pitch range)
	  fconv=1.0; % frequency stretch
	  sconv=1.0; % time stretch
	  delsp=2; 	% standard deviation of random group delay in ms
	  gdbw=70; 	% smoothing window length of random group delay (in Hz)
	  cornf=3000;  	% corner frequency for random phase (Hz)
	  delfrac=0.2;  % This parameter should be revised.
	  delfracind=0;
	  n3sgram=n2sgram; % corresponds to "bypass" button in GUI.
%-------------------------------------------
%	synthesis part %% synthesizegraded 
%-------------------------------------------
        disp('%	Now, synthesis is in progress. Please wait a moment.');
	sy=straightSynthTB06c(n3sgram,f0mix,shiftm,fs, ...
        pcnv,fconv,sconv,gdbw,delfrac,delsp,cornf,delfracind, ...
	aperiodiccomp(apv,dpv,5,f0raw,f0shiftm,fftl)); % 23/Sept./1999
	dBsy=powerchk(sy,fs,15); % 23/Sept./1999
	cf=(dB(32768)-22)-dBsy;
	sy=sy*(10.0.^(cf/20));
	disp('%	Done!');
%-----------------------------------------------------
% File OUTPUT part 
%-----------------------------------------------------

	% get filename
	base = strtok(fname,'.'); % take part of input 
				  %filename before ".wav" ext
	I = int2str(i);
	J = int2str(j);
	K = int2str(k);
   	sndfname = strcat(base,'.h',K,'H',I,'L',J,'.wav')
	parfname = strcat(base,'.h',K,'H',I,'L',J,'.par');
   	disp('% Saving a file...');
   	disp(' ');
   	wavwrite(sy/32768,44100,16,sndfname);	% fs = 44100 Hz, 16 bits

%-- Save file in different format
%   	fid = fopen([tpath sndfname],'w','ieee-le');
%   	fwrite(fid,sy,'short');
%   	fclose(fid); 

%-- Save "f0values" as text 
	parsL = size(Ptime);
	pars = zeros(4,parsL(2));
	pars (1,:) = Ptime(i,:,j,k);	
	pars (2,:) = Pnews(i,:,j,k);
	pars (3,:) = Pmixes(i,:,j,k);
	pars (4,:) = Pother(i,:,j,k); % 6/26/2000 added 
   	fid = fopen(parfname,'w');
	fprintf(fid,'%4.2f\t%4.2f\t%4.2f\t%4.2f\n',pars);  
		% Data format in .par file: 6/27/2000
		%		 col1	col2	col3     col4
		%		 Ptime	Pnews	Pmixes  Pother
		% row1	t=1    xxxx.xx xxxx.xx xxxx.xx  f0dec
		% row2  t=mk0t xxxx.xx xxxx.xx xxxx.xx  f0dec2 (mark1..mark11)
		%  :     :       :       :        :     awindow
		%					window
		%					slope factor
		%					l (H range)
		%					m (L range)
		%					n (S range)
		%					f0H preset 
		% rowN...depends on xx and yy array in my_f0modXX script

   	fclose(fid); 
   end % end of if
  end % end of for loop k
 end % end of for loop j
end % end of for loop i

cd ..






