% my_synorg.m
% Purpose: resynthesize with no f0 manipulation
% Input:   f0raw
% Mafuyu Kitahara
% 6/14/2000 created

%-----------------------------------------------------
%       Synthesis parameters (Excised from straightCiV1)
%-----------------------------------------------------
	  pcnv=1.0; 	% pitch stretch
	  fconv=1.0; 	% frequency stretch
	  sconv=1.0; 	% time stretch
	  delsp=2; 	%  standard deviation of random group delay in ms
	  gdbw=70; 	% smoothing window length of random group delay (in Hz)
	  cornf=3000;  	% corner frequency for random phase (Hz)
	  delfrac=0.2;  % This parameter should be revised.
	  delfracind=0;
	  n3sgram=n2sgram; % corresponds to "bypass" button in GUI.
%-------------------------------------------
%	synthesis part %% synthesizegraded 
%-------------------------------------------
        disp('%	Now, synthesis is in progress. Please wait a moment.');
	sy=straightSynthTB06c(n3sgram,f0raw,shiftm,fs, ...
        pcnv,fconv,sconv,gdbw,delfrac,delsp,cornf,delfracind, ...
	aperiodiccomp(apv,dpv,5,f0raw,f0shiftm,fftl)); % 23/Sept./1999
	dBsy=powerchk(sy,fs,15); % 23/Sept./1999
	cf=(dB(32768)-22)-dBsy;
	sy=sy*(10.0.^(cf/20));
	disp('%	Done!');
%-----------------------------------------------------
% File OUTPUT part 
%-----------------------------------------------------
	base = strtok(fname,'.'); % take part of input 
				  %filename before ".wav" ext
   	sndfname = strcat(base,'synorg.wav')
   	disp('% Saving a file...');
   	disp(' ');
   	wavwrite(sy/32768,44100,16,sndfname);	% fs = 44100 Hz, 16 bits
%   	fid = fopen([tpath sndfname],'w','ieee-le');
%   	fwrite(fid,sy,'short');
%   	fclose(fid); 














